diff --git a/src/include/utils/snapshot.h b/src/include/utils/snapshot.h
index df79e3a..1b1d1c3 100644
--- a/src/include/utils/snapshot.h
+++ b/src/include/utils/snapshot.h
@@ -63,6 +63,73 @@ typedef struct SnapshotData
 } SnapshotData;
 
 /*
+ * Declarations for GetRunningTransactionData(). Similar to Snapshots, but
+ * not quite. This has nothing at all to do with visibility on this server,
+ * so this is completely separate from snapmgr.c and snapmgr.h
+ * This data is important for creating the initial snapshot state on a
+ * standby server. We need lots more information than a normal snapshot,
+ * hence we use a specific data structure for our needs. This data
+ * is written to WAL as a separate record immediately after each
+ * checkpoint. That means that wherever we start a standby from we will
+ * almost immediately see the data we need to begin executing queries.
+ */
+typedef struct RunningXact
+{
+	/* Items matching PGPROC entries */
+	TransactionId	xid;			/* xact ID in progress */
+
+	/* Items matching XidCache */
+	bool        	overflowed;
+	int	        	nsubxids;		/* # of subxact ids for this xact only */
+
+	/* Additional info */
+	uint32     		subx_offset;	/* array offset of start of subxip,
+									 * zero if nsubxids == 0
+									 */
+} RunningXact;
+
+typedef struct RunningXactsData
+{
+	uint32			xcnt;				/* # of xact ids in xrun[] */
+	uint32			subxcnt;			/* # of xact ids in subxip[] */
+	TransactionId 	latestRunningXid;	/* Initial setting of LatestObservedXid */
+	TransactionId	oldestRunningXid;	/* *not* oldestXmin */
+	TransactionId 	latestCompletedXid;
+
+	RunningXact	*xrun;			/* array of RunningXact structs */
+
+	/*
+	 * subxip is held as a single contiguous array, so no space is wasted,
+	 * plus it helps it fit into one XLogRecord.  We continue to keep track
+	 * of which subxids go with each top-level xid by tracking the start
+	 * offset, held on each RunningXact struct.
+	 */
+	TransactionId *subxip;		/* array of subxact IDs in progress */
+
+} RunningXactsData;
+
+typedef RunningXactsData *RunningTransactions;
+
+/*
+ * When we write running xact data to WAL, we use this structure.
+ */
+typedef struct xl_xact_running_xacts
+{
+	int				xcnt;				/* # of xact ids in xrun[] */
+	int				subxcnt;			/* # of xact ids in subxip[] */
+	TransactionId	latestRunningXid;	/* Initial setting of LatestObservedXid */
+	TransactionId	oldestRunningXid;	/* *not* oldestXmin */
+	TransactionId	latestCompletedXid;
+
+	/* Array of RunningXact(s)  */
+	RunningXact	xrun[1];		/* VARIABLE LENGTH ARRAY */
+
+	/* ARRAY OF RUNNING SUBTRANSACTION XIDs FOLLOWS */
+} xl_xact_running_xacts;
+
+#define MinSizeOfXactRunningXacts offsetof(xl_xact_running_xacts, xrun)
+
+/*
  * Result codes for HeapTupleSatisfiesUpdate.  This should really be in
  * tqual.h, but we want to avoid including that file elsewhere.
  */
